# epstool

EPSTOOL - Create or extract preview images in EPS files.
Release date: 2015-03-15

## Table of contents

- Overview
- Encapsulated PostScript Format
- Previews
- Commands
- Options
- Macintosh
- DCS 2.0
- Examples
- Notes
- Copyright
- Compiling
- Other tools
- Revision History

## Overview

Epstool is a utility to create or extract preview images in EPS files.

Features:

- Add Interchange (EPSI), DOS EPS or PICT preview.
- Extract PostScript or preview from DOS EPS or Macintosh EPSF files.
- Create preview using ghostscript.
- Automatically calculate bounding box using ghostscript and update in EPS file.
- Handle DCS 2.0.
- Works under Windows 32 and 64-bit, Unix and OS/2.

Usage: epstool command [options] input_filename output_filename

Commands (one only):

      --add-tiff6p-preview       or  -t6p
      --add-tiff6u-preview       or  -t6u
      --add-tiff4-preview        or  -t4
      --add-tiff-preview         or  -tg
      --add-interchange-preview  or  -i
      --add-metafile-preview     or  -w
      --add-pict-preview
      --add-user-preview filename
      --dcs2-multi
      --dcs2-single
      --dcs2-report
      --extract-postscript       or  -p
      --extract-preview          or  -v
      --bitmap
      --copy
      --dump
      --test-eps
      --help                     or  -h

Options:

      --bbox                     or  -b
      --combine-separations filename
      --combine-tolerance pts
      --custom-colours filename
      --debug                    or  -d
      --device name
      --doseps-reverse
      --dpi resolution
      --dpi-render resolution
      --ignore-information
      --ignore-warnings
      --ignore-errors
      --gs command
      --gs-args arguments
      --mac-binary
      --mac-double
      --mac-rsrc
      --mac-single
      --missing-separations
      --page-number page
      --quiet
      --rename-separation oldname  newname
      --replace-composite

## Encapsulated PostScript Format (EPS)

EPS is a specialised form of a PostScript file that complies with the Document Structuring Conventions (DSC) and is intended to be embedded inside another PostScript file. An EPS file must contain a special first line that identifies it as an EPS file (e.g. `%!PS-Adobe-3.0 EPSF-3.0`) and it must contain a `%%BoundingBox:` line. The EPS file only draws within the rectangle defined by the bounding box. The PostScript code must avoid using PostScript operators that would interfere with the embedding. These include operators with global effects such as changing the page size and changing the half tone screen.

## Previews

EPS files may contain a preview to be used by programs that can't interpret the PostScript code. There are three ways to add a preview to an EPS file.

Interchange
  This preview is included within PostScript comments in a section marked %%BeginPreview: / %%EndPreview. The actual image data is stored in hexadecimal format. This format is most commonly used on Unix.
DOS EPS
  The preview is a TIFF or Windows Metafile. A DOS EPS file has a 30 byte binary header which gives offsets and lengths for the PostScript, TIFF and Windows Metafile sections. You can't send a DOS EPS file directly to a printer - you have to remove the binary header and preview first. This format is most commonly used on MS-Windows.
PICT
  The preview is in PICT format stored in the resource fork of the file. This format is most commonly used on the Macinstosh. Epstool provides limited support for this format.

## Commands

One of the following commands must be specified. Trying to use more than one command isn't helpful.

--add-tiff6p-preview or -t6p
  Add a TIFF 6 preview compressed with packbits (simple run length encoding). The preview will normally be full colour, but you can make it greyscale by adding the option `--device bmpgray` or `--device pgmraw`, or monochrome using `--device bmpmono` or `--device pbmraw`.
--add-tiff6u-preview or -t6u
  Add a TIFF 6 uncompressed preview. See `--add-tiff6p-preview` for how to add a greyscale or monochrome preview.
--add-tiff4-preview or -t4
  Add a TIFF 4 preview. The preview is monochrome and is intended for use with old programs that won't read TIFF6, such as Word Perfect 5.1 for DOS.
--add-tiff-preview or -tg
  Add a TIFF preview using ghostscript to generate the TIFF file. You must specify a suitable TIFF device using `--device`. If you want a compressed monochrome image, you might use `--device tiffg3`.
--add-interchange-preview or -i
  Add a monochrome interchange preview
--add-metafile-preview or -w
  Add a Windows Metafile (WMF) preview. The metafile will contain a bitmap, not vector information. The preview will normally be full colour. See `--add-tiff6p-preview` for how to add a greyscale or monochrome preview.
--add-pict-preview
  Add a Mac PICT preview. EPSF files with PICT previews can generally be used only on Mac computers. The preview will be full colour. The AppleSingle and MacBinary formats will contain the EPSF and the preview. The AppleDouble or Resource format will contain the preview only and needs to accompany the original EPSF file. To specify the file format use `--mac-single`, `--mac-double`, `--mac-binary` or `--mac-rsrc`.
--add-user-preview filename
  Add a user supplied image as a preview. The image can be a Windows bitmap, a PBMPLUS file, a TIFF image or a Windows Metafile. Window bitmaps and PBMPLUS files will be converted to TIFF6 compressed with packbits. TIFF and Windows Metafile images will be added unchanged.
--bitmap
  Create a bitmap of the area within the EPS bounding box. The bitmap type must be specified with `--device`. If processing a DCS 2.0 file, the separation can be specified with `--page-number`.
--copy
  Copy the EPS file. This is generally used with the `--bbox` option to update the bounding box.
--dcs2-multi
  Convert DCS 2.0 separations to multiple files. See DCS 2.0. If the output name is `out.eps`, then the separations would be named `out.eps.Cyan` etc.
--dcs2-single
  Convert DCS 2.0 separations to a single file. See DCS 2.0.
--dcs2-report
  Write the file type, preview type, bounding boxes, separation names, lengths and CMYK values to standard output. This can be used to identify if a DCS 2.0 file is missing the composite page or preview.
--dump
  Display some information about the file type and DSC comments.
--extract-postscript or -p
  Extract the PostScript section from a DOS EPS or MacBinary/AppleSingle file.
--extract-preview or -v
  Extract the preview section from a DOS EPS or MacBinary/AppleSingle file.
--help or -h
  Display a summary of the epstool commands and options.
--test-eps
  Partially test if a file complies with the EPSF specification.

## Options

--bbox or -b
  Calculate the bounding box using the ghostscript `bbox` device and update in the EPS file.
--combine-separations filename
  Combine the separations of the input DCS 2.0 file with those of this file. It is an error if the bounding boxes do not match or they contain separations with the same name. This option must be used with `--dcs2-multi` or `--dcs2-single`. The composite page may later need to be updated with `--replace-composite`.
--combine-tolerance pts
  When using `--combine-separations`, allow the bounding boxes to vary by up to pts points. The default is 0 so the bounding boxes must match exactly.
--custom-colours filename
  When using `--replace-composite` on a DCS 2.0 file, use the colours specified in this file in preference to those specified in the composite page.
--debug or -d
  Be more verbose about progress. Do not remove temporary files.
--doseps-reverse
  When writing a DOS EPS file (TIFF or WMF preview), the default is to write the PostScript before the preview. Using `--doseps-reverse` puts the preview before the PostScript section, which is required by some buggy programs. Either order is correct.
--device name
  Specify a ghostscript device to be used when creating the preview or bitmap. For `--add-tiff-preview` this must be one of the ghostscript tiff devices (e.g. tiffg3, tiff24nc). For any other preview, it must be one of the bmp or pbmplus devices (e.g. bmpgray, bmp16m, pgmraw, ppmraw). For bitmap output (`--bitmap`) it can be any ghostscript bitmap device.
--dpi resolution
  Set the resolution of the preview or bitmap. The default is 72 dpi.
--dpi-render resolution
  Render at a higher resolution set by `--dpi-render`, then down sample to the resolution set by `--dpi`. This works when adding a preview image or using `--replace-composite`, but not when using `--bitmap`. This improves the preview quality when the original contains a pre-rendered image and `--dpi-render` is set to match the original target printer.
--ignore-information
  Ignore information messages from the DSC parser. Use at your own risk. These messages usually indicate that something is wrong with an EPS file, but that most EPS handlers probably won't care. An example is a line with more than 255 characters.
--ignore-warnings
  Ignore warnings from the DSC parser. Use at your own risk. These messages are usually about faults in the DSC comments that are recoverable by epstool, but may confuse other EPS handlers. An example is a bounding box that incorrectly uses floating point numbers instead of integer.
--ignore-errors
  Ignore errors from the DSC parser. Use at your own risk. You really should fix the EPS file first.
--gs command
  Specify the name the ghostscript program. On Unix the default is `gs`. On Windows, epstool will check the registry for installed versions of ghostscript and use the latest, otherwise it will use `gswin32c.exe`.
--gs-args arguments
  Specify additional Ghostscript arguments. This might be used to select anti-aliasing with `"-dTextAlphaBits=4 -dGraphicsAlphaBits=4"`
--output filename
  Specify the output file (instead of using the second file parameter). Using the filename `-` causes epstool to write to standard output, which requires the use of `--quiet`.
--mac-binary
  When adding a PICT preview, use the MacBinary I format for the Mac.
--mac-double
  When adding a PICT preview, use the AppleDouble format for the Mac.
--mac-rsrc
  When adding a PICT preview, use the Resource format for the Mac.
--mac-single
  When adding a PICT preview, use the AppleSingle format for the Mac.
--missing-separations
  When writing a DCS 2.0 file, epstool will normally fail if a separation is missing. When this option is used, it will remove references to missing separations when writing the file.
--page-number page
  When creating a bitmap with `--device` from a DCS 2.0 file, page specifies the separation to be used. Page 1 is the composite and page 2 is the first separation. Use `--dcs2-report` to get the list of separations.
--quiet
  Try to run without writing to standard output.
--rename-separation oldname newname
  When copying a DCS 2.0 file with `--dcs2-multi` or `--dcs2-single`, rename separation oldname to newname. This option implies `--missing-separations`. It is assumed that the new name is just an alias for the same colour and that the CMYK or RGB values for the separation are not changed. This option may be used multiple times. This must be used if the input file has two separations with the same name.
--replace-composite
  Some DCS 2.0 files do not have an image in the composite page. This option replaces the composite page with a CMYK image derived from the separations. This option must be used with `--dcs2-multi` or `--dcs2-single`. See also the options `--dpi` and `--custom-colours`.

## Macintosh

The Macintosh does not use a flat file system. Each file can have a data fork and a resource fork. EPSF files have the PostScript in the data fork, and optionally have a preview in the resource fork as a PICT image. In addition, file type is obtained from the finder info rather than a file extension. File types use a four character code such as "EPSF" or "PICT". When Macintosh files are copied to a foreign file system, the resource fork may be left behind. Alternatives to retain the resource fork are to package the finder data, data fork and resource fork in a single MacBinary or AppleSingle file, or to put the data fork in a flat file and the finder info and resource fork in an AppleDouble file. The Mac OSX finder will handle AppleDouble files automatically when copying files to and from a foreign file system. When copying `test.eps` to a foreign file system, the data fork would be written as `test.eps` and the finder info and resource fork to the AppleDouble file `._test.eps` or `.AppleDouble/test.eps`.

Epstool can read MacBinary and AppleSingle files. It can write MacBinary I, AppleSingle, AppleDouble or Resource files. Files written by epstool will have type `EPSF` and creator `MSWD`. When adding a preview to `test.eps`, it is suggested that you create the MacBinary file `test.eps.bin`. On a Macintosh computer you then need to extract it with StuffIt Expander. Another alternative is to write the AppleDouble file to `._test.eps` then copy both files to a file system accessible to a Mac computer.

If the output file name starts with `.` then AppleDouble will be assumed, otherwise if it ends with `.as` then AppleSingle will be assumed, otherwise if it ends with `.rsrc` or `/rsrc` then Resource will be assumed, otherwise MacBinary will be assumed. When writing a MacBinary file, it is recommended that you end the filename in `.bin`. To force the file type, use `--mac-single`, `--mac-double`, `--mac-binary` or `--mac-rsrc`.

On Mac OS X you can access a file's resource fork from command line tools by appending `/rsrc` to the original file name. The easiest way to add a preview to the file `test.eps` on Mac OS X is to let epstool write in `--mac-rsrc` format to `test.eps/rsrc` (see Examples).

## Desktop Color Separations (DCS 2.0)

The Desktop Color Separation (DCS) image file format contains a low resolution preview, a main file with the full resolution composite image, and colour separations with full resolution separated plates. The separations will typically contain Cyan, Magenta, Yellow, Black and possibly spot colours. There are two versions of DCS 2.0.

Multiple File
  The main file contains `%%PlateFile: (name) EPS Local filename` comments which give the filenames of the separation plates. The main file may contain a low resolution DOS EPS preview. The separation files do not contain previews.
Single File
  This is an abuse of the EPS specification. The single file contains the main file and the separations concatenated together, which makes the DSC comments incorrect. The main file specifies the byte offsets to the separations using `%%PlateFile: (name) EPS #offset size`. The single file may then be placed inside a DOS EPS file with a low resolution preview. By default, epstool writes single file DCS 2.0.

Epstool can add previews to single and multiple file DCS 2.0. It can split single file DCS 2.0 into multiple files and vice versa. This allows a single file DCS 2.0 to be split, the composite image replaced, a new preview created, and then be recombined into a single file.

Some DCS 2.0 files do not have an image in the composite page. To determine if the composite page does not contain an image, use `--dcs2-report` and look to see if the composite section is very short. Using `--dcs2-single --replace-composite` replaces the composite page with the headers of the original composite page and a body containing a CMYK image derived from the separations. Set the resolution of the CMYK image using `--dpi`.

When replacing the composite page with a CMYK image using `--replace-composite`, the `--custom-colours` option is useful for dealing with DCS 2.0 files that have incorrect CMYK colours, for example specifying that the varnish layer is grey. Each line of the CMYK colours file is formatted like a DSC `%%CMYKCustomColor:` or `%%RGBCustomColor:` line, as shown in the example below.

    %%CMYKCustomColor: 0.00 0.00 0.00 0.00 Varnish
    %%CMYKCustomColor: 1.00 0.68 0.00 0.12 (Dark Blue)
    %%RGBCustomColor: 0.5 0.0 0.0 (Dark Red)

DCS2 files should not have two separations with the same name. Epstool will not allow a DCS2 output file to have duplicate separation names. Use `--rename-separation` to resolve this.

## Examples

Add colour preview (24bit/pixel) to EPS file
`epstool -t6p tiger.eps output.eps`

Add TIFF (G3 Fax) preview to tiger.eps.
`epstool --add-tiff-preview --device tiffg3 tiger.eps output.eps`
Any GS TIFF device can be used, e.g. tiffg4, tiffpack

Extract TIFF preview from tiger.eps
`epstool -v tiger.eps tiger.tif`

Fix incorrect %%BoundingBox then add TIFF4 preview.
`epstool --bbox -t4 golfer.eps output.eps`

Adjust the BoundingBox of an existing EPS file, but don't add a preview:
`epstool --copy --bbox input.eps output.eps`

Add user supplied Windows Metafile to EPS file. Typically used when an application can export EPS and WMF separately but can't export EPS with WMF preview.
`epstool --add-user-preview logo.wmf logo.eps output.eps`

Add a PICT preview and write an AppleDouble file.
`epstool --add-pict-preview --mac-double tiger.eps ._tiger.eps`
To be used by a Mac, both `tiger.eps` and `._tiger.eps` need to be on a foreign file system accessible to the Mac.

On Mac OS X you can access a file's resource fork from command line tools by appending "/rsrc" to the file's original name. Add a PICT preview, overwriting the existing resources.
`epstool --add-pict-preview --mac-rsrc tiger.eps tiger.eps/rsrc`

## Notes

When adding a WMF preview to an EPS file using `-add-user-preview filename`, the placeable metafile header is removed from the metafile as it is put into the EPS file. When extracting a WMF preview from an EPS file, a placeable metafile header is created from the EPS BoundingBox information. This placeable metafile header assumes that the WMF has its origin at (0,0), which might not be correct.

When epstool is creating a TIFF or WMF preview, it will convert palette colour images into 24-bit/pixel.

The environment variable TEMP should point to a writeable directory for temporary files. If not defined, /tmp will be used for Unix and the current directory will be used for other platforms.

## Copyright

Copyright (C) 1995-2005 Ghostgum Software Pty Ltd. All rights reserved.

This software is provided AS-IS with no warranty, either express or implied.

This software is distributed under licence and may not be copied, modified or distributed except as expressly authorised under the terms of the licence contained in the file LICENCE in this distribution.

For more information about licensing, please refer to http://www.ghostgum.com.au/ or contact Ghostsgum Software Pty Ltd, 25 Kennedy St, Glen Waverley VIC 3150, AUSTRALIA, Fax +61 3 9886 6616.

Author: Russell Lang, Ghostgum Software Pty Ltd
Internet: gsview at ghostgum.com.au

## Compiling

To compile epstool on Unix, use
`make -f src/epstool.mak`
To build an RPM
`rpmbuild -ta epstool-N.NN.tar.gz`

To compile epstool on MS-Windows, use
`nmake -f srcwin/epstool.mak VCVER=71`

## Other tools

Other tools that can add previews to EPS files are

- GSview (slightly older code than epstool)
- ps2epsi, which is part of Ghostscript. This only adds Interchange previews.
- ps2epsplus for creating Mac EPS files on a Mac.
- ps2epsmac for creating Mac EPS files under Unix.

## Revision History

### 3.09 2015-03-15

Windows makefile update for recent compilers.
Bug fix.

### 3.08 2005-06-10

Fix Unix-like makefiles to work with non-GNU make.
Install CSS file gsview.css.
Added --ignore-information to ignore DSC parser information messages.
Fixed handling of --ignore-warnings and --ignore-errors so that these are now required to process files with warnings or errors.
Added makefile support for cygwin packages.
Added --test-eps making a partial test of EPS compliance.
Added --dump for displaying summary of DSC information.
Builds as Win64 for AMD64, using either Microsoft Visual Studio .NET 2003 with Windows Server 2003 DDK, or with Microsoft Visual Studio .NET 2005 beta.
Builds under OS/2 with gcc/emx.

### 3.07 2005-01-07

Fix portability issue for Unix-like systems without shared libraries.
Interchange preview was restricted to 1bit/pixel. Add 8bit/pixel grey which isn't commonly used.
Explicitly set the page size when calculating the bounding box, to avoid getting erroneous results when the user changes the default page size with -sPAPERSIZE=a4 or by modifying gs_init.ps to change the default page size on startup. This was a problem with some badly configured Linux distributions.

### 3.06 2004-11-28

Fix interchange previews which were inverted.
Fix --bitmap for EPS file without a page, which was broken when --page-number was added.
Identify DCS 1.0 as itself, not DCS 2.0.
More portable on Unix-like systems.

### 3.05 2004-04-22

Write duplicate DCS2 separations to unique files with --dcs2-multi.
When renaming a DCS2 separation, only rename the first occurence of the name, to allow files with duplicate separation names to be fixed.
Do not allow duplicate separations in an output file. This must be resolved with --rename-separations
Added --page-number to allow bitmaps of separations to be created.
Fix bitmap output to stdout with "--bitmap --output -".
Prevent crash when given a PDF file.
Put --gs-args near the end of the GS command line, to allow PostScript commands to be embedded.

### 3.04 2004-01-17

Fix bug that caused a crash with -t6p on non-Windows systems.
Allow output to stdout with filename "-".
Remove blank lines from interchange preview.
Rearrange files in the epstool distribution so that it compiles with a simple 'make' on Linux.

### 3.03 2003-10-18

Added Macintosh AppleDouble, AppleSingle, MacBinary and Resource formats, and the ability to add/remove PICT previews.
Added --combine-separations and --combine-tolerance. Allow spaces to occur in unquoted DCS1 separation file names.

### 3.02 2003-05-06

Added man page and some build updates for Debian.

### 3.01 2003-02-28

Added --doseps-reverse.
Added --rename-separation. Added bounding box to --dcs2-report output.

### 3.0 2002-09-17

Major rewrite.
Command line changes.
Use ghostscript bbox device for calculating bounding box.
Supports multiple file DCS 2.0.
Add preview to single file DCS 2.0.
Replace composite page of DCS 2.0 with an image derived from the separations.
Down sample images to provide anti-aliasing.
Removed option to extract a page from a multipage file. The input file must now be EPS.

### 2.2 2002-04-30

Release with GSview 4.3.
Fixed bug in extracting a page.
Handle single file DCS 2.0.
Added '-k' to create a bitmap of the EPS.

### 2.1 2002-02-07

Release with GSview 4.2.

### 2.0 2001-11-23

Release with GSview 4.1.
Remove %%BoundingBox from trailer when adding it to header.

### 1.92 2001-10-20

Release with GSview 4.05 beta.
Added -aargs to separate arguments from -g. This is needed because program name is surrounded by quotes and so some shells were treating the arguments as part of the program name.

### 1.91 2001-10-06

Release with GSview 4.03 beta.

### 1.9 2001-07-27

Release with GSview 4.01 beta.
Ignore DSC warnings with -e1, ignore DSC errors with -e2.

### 1.8 2001-06-02

Release with GSview 4.0.

### 1.7 2001-03-30

Allow DSC warnings to be ignored with -e.

### 1.6 2000-12-28

Release with GSview 3.6.
Write correct page ordinal when extracting a page.
Correctly handle DOS EPS files again.

### 1.5 2000-12-16

Release with GSview 3.5.

### 1.32 2000-11-06

Updated DSC parser.
Release with GSview 3.41 beta.

### 1.4 2000-06-30

Fixed handling of files without trailers.

### 1.3 2000-06-25

Put quotes around Ghostscript EXE name for Windows, OS/2 and Unix. Released with GSview 3.1.

### 1.21 2000-06-15

Minor fixes for Linux build.

### 1.2 2000-06-15

Release with GSview 3.0.

### 1.10 2000-04-01

Fixes to DSC parser.

### 1.09 2000-03-11

New DSC parser.
Added #pragma pack(1) needed by MSVC++.
Modified BMP reading so it works even if byte packing not used.
BMP reading might now work with big-endian architectures, so might be able to use BMP devices on Unix (if compiled into Ghostscript). (Untested).

### 1.08 2000-02-15

Fixed incorrect switch statement in psfile_extract_header()
Fixed -b -c to change the first line to EPS.
Added -sWIDTHxHEIGHT for use with -b -c and large page sizes.

### 1.07 1998-12-23

Cope with badly written EPS files that leave items on the stack or dictionary stack.

### 1.06 1998-09-13

Page calculation for descending page order was wrong.
If a multipage non-EPS file was used as input, the output didn't contain the correct single page (or copied garbage).
Added macro for SUNOS4 to use bcopy instead of memmove.

### 1.05 1997-12-09

When calculating the bounding box from a bitmap, round the area outwards by 0.5 pixels.

### 1.04 1997-11-29

Released with GSview 2.4

### 1.03 1997-09-22

TIFF4 preview didn't work from 24bit/pixel source bitmap.
TIFF 6 packbits didn't compress properly for some data (and consquently caused heap corruption).
Fixed TIFF 6 output when using palette (4 or 8 bit/pixel).

### 1.02 1997-02-15

Removed requirement for EPS file to use showpage.
Added -c to allow correction of %%BoundingBox
When calculating %%BoundingBox, render to a page of letter width and A4 height.
Avoid integer overflow on 16bit machines when calculating width and height.
If TEMP undefined, default to /tmp on Unix.

### 1.01 1996-11-07

Release separate from GSview. No code changes.
Includes Win32 (epstool.exe) and OS/2 (epstool2.exe) EXEs.

### 1.0 1996-10-13

Not a beta version. Included with GSview 2.1.

### 0.81 beta 1996-09-12

Added TIFF packbits compression.
Added -zdevice.
-t5 replaced by -t6u, -t6p.
-wdevice replaced by -w -zdevice
-ttiff3 replaced by -tg -ztiffg3

### 0.8 beta 1996-09-09

Makefile target for Win32.
Add WMF for all platforms.
Removed restriction that structures must be byte aligned under Unix.
Must still be byte aligned under DOS and OS/2.

### 0.7 alpha 1995-10-20

Fixed a few error messages.
Use @file to reduce Ghostscript command line length under MS-DOS and OS/2.
Added -q option to GSview and -dQUIET option to Ghostscript command line to allow EPS files to be written to stdout.

### 0.6 alpha 1995-10-12

Delete temporary bmp file.
Add user supplied preview to a DOS EPS file (which already had a preview) was wrong.

### 0.5 alpha 1995-09-27

Put stdout into binary mode.
Write placeable WMF header correctly on 32bit and big-endian machines.

### 0.4 alpha 1995-09-15

Remove placeable WMF header when adding to EPS file, add placeable
WMF header when extracting from EPS file.

### 0.3 alpha 1995-09-14

First release separate from GSview.

## End of epstool documentation